﻿using System;
using System.Collections.Generic;
using System.Xml;

namespace 도서관리프로그램_XmlDocument__테스트
{
    public class BookManager
    {
        XmlDocument xdoc = new XmlDocument();
        static BookManager bm = new BookManager();
        public static BookManager BM
        {
            get
            {
                return bm;
            }
        }
        BookManager()
        {
            XmlDeclaration xdec;
            xdec = xdoc.CreateXmlDeclaration("1.0", null, null);
            xdoc.InsertBefore(xdec, xdoc.DocumentElement);
            XmlComment xcom;
            xcom = xdoc.CreateComment("도서 데이터");
            xdoc.AppendChild(xcom);
            XmlElement re = xdoc.CreateElement("Books");
            xdoc.AppendChild(re);
        }
//<?XML VERSION = "1.0" ?>
//< !--도서 데이터-- >
//< Books >
//    < CompanyName > 언제나 휴일</CompanyName>
//    <BookCount>2</BookCount>
//    <Book count = "100" >
//        < Title > C언어 </ Title >
//        < Author > 홍길동 </ Author >
//    </ Book >
//    < Book count="100">
//        <Title>C#</Title>
//        <Author> 홍길순</Author>
//    </Book>
//</Books>

        public string CompanyName
        {
            get
            {
                XmlNode rn = xdoc.DocumentElement;
                if(rn == null)
                {
                    return string.Empty;
                }
                XmlNode cn = rn.SelectSingleNode("CompanyName");
                if(cn == null)
                {
                    return string.Empty;
                }
                return cn.InnerText;
            }
            set
            {
                XmlNode rn = xdoc.DocumentElement;
                XmlElement xe = xdoc.CreateElement("CompanyName");
                xe.InnerText = value;
                rn.AppendChild(xe);
                XmlElement ce = xdoc.CreateElement("BookCount");
                ce.InnerText = "0";
                rn.AppendChild(ce);
            }
        }
        public IEnumerable<Book> Books
        {
            get
            {
                List<Book> books = new List<Book>();
                XmlNode rn = xdoc.DocumentElement;
                if(rn == null)
                {
                    return books;
                }
                XmlNodeList xnl = rn.SelectNodes("Book");
                foreach(XmlNode sn in xnl)
                {
                    string title = string.Empty;
                    string author = string.Empty;
                    int count = 0;
                    XmlNode tn = sn.SelectSingleNode("Title");
                    title = tn.InnerText;
                    XmlNode an = sn.SelectSingleNode("Author");
                    author = an.InnerText;
                    XmlElement xe = sn as XmlElement;
                    count = int.Parse(xe.GetAttribute("count"));
                    Book book = new Book(title, author, count);
                    books.Add(book);
                }
                return books;
            }
        }

        public void AddBook(string title, string author, int count)
        {
            XmlElement bookxe = xdoc.CreateElement("Book");
            bookxe.SetAttribute("count", count.ToString());
            XmlElement te = xdoc.CreateElement("Title");
            te.InnerText = title;
            bookxe.AppendChild(te);
            XmlElement ae = xdoc.CreateElement("Author");
            ae.InnerText = author;
            bookxe.AppendChild(ae);
            XmlElement root = xdoc.DocumentElement;
            root.AppendChild(bookxe);
            XmlNode rn = root;
            XmlNode cn = rn.SelectSingleNode("BookCount");
            int cnt = int.Parse(cn.InnerText);
            cnt++;
            cn.InnerText = cnt.ToString();
        }

        internal void InBook(string title, int count)
        {
            XmlNode rn = xdoc.SelectSingleNode("Books");
            XmlNodeList xnl = rn.SelectNodes("Book");
            foreach(XmlNode sn in xnl)
            {
                XmlNode tn = sn.SelectSingleNode("Title");
                if(tn.InnerText == title)
                {
                    XmlElement xe = sn as XmlElement;
                    int oc = int.Parse(xe.GetAttribute("count"));
                    oc += count;
                    xe.SetAttribute("count", oc.ToString());
                    return;
                }
            }
        }

        internal void OutBook(string title, int count)
        {
            XmlNode rn = xdoc.SelectSingleNode("Books");
            XmlNodeList xnl = rn.SelectNodes("Book");
            foreach (XmlNode sn in xnl)
            {
                XmlNode tn = sn.SelectSingleNode("Title");
                if (tn.InnerText == title)
                {
                    XmlElement xe = sn as XmlElement;
                    int oc = int.Parse(xe.GetAttribute("count"));
                    oc -= count;
                    xe.SetAttribute("count", oc.ToString());
                    return;
                }
            }
        }

        internal void Remove(string title)
        {
            XmlNode rn = xdoc.SelectSingleNode("Books");
            XmlNodeList xnl = rn.SelectNodes("Book");
            foreach (XmlNode sn in xnl)
            {
                XmlNode tn = sn.SelectSingleNode("Title");
                if (tn.InnerText == title)
                {
                    rn.RemoveChild(sn);
                    XmlNode cn = rn.SelectSingleNode("BookCount");
                    int cnt = int.Parse(cn.InnerText);
                    cnt--;
                    cn.InnerText = cnt.ToString();
                    return;
                }
            }
        }

        internal void Reset()
        {
            XmlNode rn = xdoc.SelectSingleNode("Books");
            XmlNodeList xnl = rn.SelectNodes("Book");
            foreach(XmlNode sn in xnl)
            {
                rn.RemoveChild(sn);
            }
            
            XmlNode cn = rn.SelectSingleNode("BookCount");

            cn.InnerText = "0";
        }

        internal void Save(string fname)
        {
            xdoc.Save(fname);
        }

        internal void Load(string fname)
        {
            xdoc.Load(fname);
        }
    }
}